# $Id: Browser.rb,v 1.6 2002/08/09 20:48:25 ljulliar Exp $
#
# Authors:  NISHIO Mizuho
# Contributors:
#
# This file is part of the FreeRIDE project
#
# This application is free software; you can redistribute it and/or
# modify it under the terms of the Ruby license defined in the
# COPYING file.
#
# Copyright (c) 2002 NISHIO Mizuho. All rights reserved.
#

# require 'plugins/System_GuiCore/GuiSetup.rb'
# require 'plugins/FRBrowser/Render/Fox/BrowserRenderFox'

require 'plugins/FRBrowser/code_object'
require 'plugins/FRBrowser/simple_parser'
require 'plugins/FRBrowser/browser_service'


module FreeRIDE

  module FRBrowser

    extend FreeBASE::StandardPlugin

    @dockpane_slot = nil
    
    def self.start(plugin)
      # create renderer object. FreeFRIDE must have only one object.
      plugin["/system/ui/components/FRBrowser/render/init"]
      
      # create a browser dock pane and attach it to the left dockbar
      @dockpane_slot = plugin["/system/ui/components/DockPane/pool/FRBrowser"]
      @dockpane_slot.attr_title = "FRBrowser"
      
      # attach the frame to the browser pane 
      @dockpane_slot.data = "/system/ui/components/FRBrowser/render/frame"      

      dockbar_west = plugin["/system/ui/components/DockBar/pool/west"].manager
      dockbar_west.attach(@dockpane_slot.path)


      
      # Create the Browser menu
      browser_slot = plugin["/system/ui/commands/AppCommands/FRBrowser"]
      browser_slot.data = GenericCommand.new("&Update Browser\tCtl-U") {
        plugin["/system/ui/services/FRBrwoser"].call
      }

      toolsmenu = plugin["/system/ui/components/MenuPane/pool/Tools_menu"].manager
      toolsmenu.add_command(browser_slot.path)
      
      plugin["/system/ui/services/FRBrwoser"].proc.set_proc() {
	self.update_browser_tree
      }
      
      # Now only is the plugin running
      plugin.transition(FreeBASE::RUNNING)
    end
    
    # return the dockpane slot on which the brwoser UI is docked
    def self.dockpane_slot
      @dockpane_slot
    end
    
  end

end
