module FreeRIDE

  module FRBrowser

    @active = false


    def self.get_current_scintiila
      editpane = dockpane_slot["/system/ui/current/EditPane"].data

      scintilla = nil
      # FIX ME
      editpane.renderer.instance_eval <<-EOF
      scintilla = @scintilla
      EOF

      scintilla
    end
    
    def self.update_browser_tree
      unless @active
	obj = FRBrowserRenderFox.__tree__
	@browser_tree = BrowserTree.new(obj)
	@active = true
	@parser = FRParser::SimpleParser.new
      end

      str = nil
      scintilla = get_current_scintiila
      
      unless scintilla.respond_to?('getText')
	puts "can't get buffer: '#{scintilla.type}#getText' is not found"
	return nil
      else
	n = scintilla.getTextLength + 1
	#n1 = scintilla.getLength + 1
	#p n, n1
	str = scintilla.getText(n)
      end

      str2 = str + "\n\n"
      io = FRParser::SimpleStringIO.new(str2, true)

      source = nil
      #p str
      begin
	source = @parser.parse(io)
      rescue StandardError, NameError
	puts $!.to_s
      ensure
	@parser.clear
	#puts 'end'
	#puts
      end

      if source
	@browser_tree.update_tree(source)
      end
    end

    def self.__browser_tree__
      @browser_tree
    end

    
    class BrowserTree

      #include Observable
      
      def initialize(renderer_obj)
	@renderer = renderer_obj

	def @renderer.on_selected(node)
	  scintilla = FRBrowser.get_current_scintiila
	  
	  unless scintilla.respond_to?('gotoLine')
	    puts "can't use #{scintilla.type}#gotoLine."
	    return nil
	  else
	    line_no = self.get_node_data(node)
	    p line_no
	    scintilla.gotoLine(line_no)
	  end
	end
	
      end

      def __rederer__
	@renderer 
      end

      def update_tree(source)
	@renderer.clear_nodes
	__append_tree(source.top_level_context, @renderer.root_node)
      end

      def __append_tree(tree, node)
	print 'Name: ', tree.name, "\n"
	if tree.name == ''
	  name = 'top'
	else
	  name = tree.name
	end
	
	new_node = @renderer.add_child_node(node, name)
	@renderer.set_node_data(new_node, tree.start_point.line_no)

	tree.each_module do |mod|
	  __append_tree(mod, new_node)
	end
	
	tree.each_singleton_class do |c|
	  __append_tree(c, new_node)
	end
	
	tree.each_class do |klass|
	  __append_tree(klass, new_node)
	end
	
	tree.each_singleton_method do |meth|
	  n = @renderer.add_child_node(new_node, meth.name)  
	  @renderer.set_node_data(n, meth.start_point.line_no)
	end

	tree.each_method do |meth|
	  n = @renderer.add_child_node(new_node, meth.name)  
	  @renderer.set_node_data(n, meth.start_point.line_no)
	end
      end
	
    end
    
  end

end
